<?php

namespace IdelibreApiPhp\Tests\Api;

use IdelibreApiPhp\Api\v2\TypeApiWrapper;
use IdelibreApiPhp\Client;
use IdelibreApiPhp\Enum\ApiPath;
use IdelibreApiPhp\Model\Reminder;
use IdelibreApiPhp\Model\Type;
use IdelibreApiPhp\Model\User;
use IdelibreApiPhp\Tests\Fixtures\TypeFixtures;
use IdelibreApiPhp\Tests\Mocker\ClientMock;
use PHPUnit\Framework\MockObject\Exception;
use PHPUnit\Framework\TestCase;
use Psr\Http\Client\ClientExceptionInterface;
use Symfony\Component\Serializer\Encoder\JsonEncoder;
use Symfony\Component\Serializer\Exception\ExceptionInterface;
use Symfony\Component\Serializer\Normalizer\AbstractNormalizer;
use Symfony\Component\Serializer\Normalizer\ArrayDenormalizer;
use Symfony\Component\Serializer\Normalizer\DateTimeNormalizer;
use Symfony\Component\Serializer\Normalizer\GetSetMethodNormalizer;
use Symfony\Component\Serializer\Normalizer\ObjectNormalizer;
use Symfony\Component\Serializer\Serializer;

class TypeWrapperTest extends TestCase
{
    protected function setUp(): void
    {
        parent::setUp(); // TODO: Change the autogenerated stub
        $this->clientMock = new ClientMock(Client::class);
        $defaultContext = [
            AbstractNormalizer::CIRCULAR_REFERENCE_HANDLER => function (object $object, ?string $format, array $context): string {
                return $object->getId();
            },
            AbstractNormalizer::CIRCULAR_REFERENCE_LIMIT => 1,
        ];
        $objectNormalizer = new ObjectNormalizer(null, null, null, null, null, null, $defaultContext);
        $getSetNormalizer = new GetSetMethodNormalizer();
        $dateTimeZoneNormalizer = new DateTimeNormalizer([DateTimeNormalizer::TIMEZONE_KEY => 'UTC']);
        $this->serializer = new Serializer([$objectNormalizer, $getSetNormalizer, new ArrayDenormalizer(),$dateTimeZoneNormalizer], [new JsonEncoder()]);
        $this->typeFixtures = new TypeFixtures();
        $this->userApi = $this->clientMock->isApiUser();

    }

    /**
     * @throws ClientExceptionInterface
     * @throws Exception
     */
    public function testGetAll()
    {
        $apiResponse ='[
            {"id":"bfdea45f-8c8e-4dc5-a2c0-26675f8a0ce5","name":"All-In","isSms":true,"isComelus":true,"isSmsGuests":true,"isSmsEmployees":true},
            {"id":"ae3d1750-6571-43a4-9f8d-bc61fd7d976b","name":"Test remote","isSms":true,"isComelus":false,"isSmsGuests":true,"isSmsEmployees":false},
            {"id":"b787b4bf-fa86-4326-84c4-857b032bb438","name":"teste type","isSms":false,"isComelus":true,"isSmsGuests":true,"isSmsEmployees":true}
        ]';

        $structureId = $this->userApi->getStructure()->getId();
        $mockClient = $this->clientMock->mockClient('get', sprintf(ApiPath::BASE_API_V2_PATH . '/types', $structureId), $apiResponse);

        $expected = [];
        foreach (json_decode($apiResponse, true) as $type) {
            $expected[] = $this->serializer->denormalize($type, Type::class);
        }

        $typeWrapper = new TypeApiWrapper($mockClient);
        $response = $typeWrapper->getAll();

        $this->assertEquals($expected, $response);
        $this->assertCount(3, $response);
        $this->assertEquals($response[0]->getName() , $expected[0]->getName());
    }

    /**
     * @throws ClientExceptionInterface
     * @throws Exception
     */
    public function testGetOne()
    {
        $apiResponse ='{
            "id":"8f9469c6-bd71-454c-a82f-93a850edeb33",
            "name":"Demo T0 - Idelibre Lsvote",
            "associatedUsers":[
                {"id":"13fe277c-e1ed-4038-bbc5-542280e9c946","username":"p.salers-elu@libriciel","email":"pmonin@libriciel.coop","firstName":"Pierre","lastName":"Salers"},
                {"id":"9f7f6f46-739a-4ae2-a30b-c65b298c5cfc","username":"c.dupont-admin@libriciel","email":"pmonin@libriciel.coop","firstName":"camille","lastName":"Dupont"},
                {"id":"15f2f5a1-689b-40a9-b8e3-83efabca4d30","username":"voxad@libriciel","email":"pmonin@libriciel.coop","firstName":"Ann","lastName":"Shaw"}
            ],
            "isSms":true,
            "isComelus":true,
            "reminder":{
                "id":"f0213a37-b212-4a48-a7ee-37e116be3a3e",
                "duration":60,
                "isActive":false
                },
            "isSmsGuests":true,
            "isSmsEmployees":true
        }';

        $structureId = $this->userApi->getStructure()->getId();
        $typeId = json_decode($apiResponse, true)['id'];
        $mockClient = $this->clientMock->mockClient('get', sprintf(ApiPath::BASE_API_V2_PATH .'/types/' . $typeId, $structureId), $apiResponse);

        $apiResponse = json_decode($apiResponse, true);
        $apiResponse['reminder'] = $this->serializer->denormalize($apiResponse['reminder'], Reminder::class);
        $expected = $this->serializer->denormalize($apiResponse, Type::class);
        $expected->setAssociatedUsers(array_map(fn($user) => $this->serializer->denormalize($user, User::class), $apiResponse['associatedUsers']));
        $expected->setReminder($apiResponse['reminder']);

        $typeWrapper = new TypeApiWrapper($mockClient);
        $response = $typeWrapper->getOne($typeId);

        $this->assertEquals($expected, $response);
        $this->assertEquals($expected->getAssociatedUsers()[0]->getId(), $response->getAssociatedUsers()[0]->getId());
    }

    /**
     * @throws ClientExceptionInterface
     * @throws Exception
     */
    public function testCreate()
    {
        $apiResponse = '{"id":"8f9469c6-bd71-454c-a82f-93a850edeb33","name":"TypeApi 15","isSms":true,"isComelus":false,"isSmsGuests":true,"isSmsEmployees":false}';

        $structureId = $this->userApi->getStructure()->getId();
        $clientMock = $this->clientMock->mockClient('post', '/api/v2/structures/' . $structureId . '/types', $apiResponse);

        $type = $this->serializer->deserialize($apiResponse, Type::class, 'json');

        $typeWrapper = new TypeApiWrapper($clientMock);
        $response = $typeWrapper->create($type);


        $this->assertInstanceOf(Type::class, $response);
        $this->assertEquals($type, $response);
        $this->assertEquals('TypeApi 15', $response->getName());
    }

    /**
     * @throws ClientExceptionInterface
     * @throws ExceptionInterface
     * @throws Exception
     */
    public function testEdit()
    {
        $apiResponse = '{"id":"8f9469c6-bd71-454c-a82f-93a850edeb33","name":"TypeApi 15","isSms":true,"isComelus":false,"isSmsGuests":true,"isSmsEmployees":false}';

        $structureId = $this->userApi->getStructure()->getId();
        $typeId = json_decode($apiResponse, true)['id'];
        $clientMock = $this->clientMock->mockClient('put', '/api/v2/structures/' . $structureId . '/types/' . $typeId, $apiResponse);

        $type = $this->serializer->deserialize($apiResponse, Type::class, 'json');

        $typeWrapper = new TypeApiWrapper($clientMock);
        $response = $typeWrapper->edit($type);


        $this->assertInstanceOf(Type::class, $response);
        $this->assertEquals($type, $response);
        $this->assertEquals('TypeApi 15', $response->getName());
    }

    /**
     * @throws ClientExceptionInterface
     * @throws Exception
     */
    public function testDelete()
    {
        $type = '{"id":"8f9469c6-bd71-454c-a82f-93a850edeb33","name":"Demo T0 - Idelibre Lsvote","associatedUsers":[{"id":"13fe277c-e1ed-4038-bbc5-542280e9c946","username":"p.salers-elu@libriciel","email":"pmonin@libriciel.coop","firstName":"Pierre","lastName":"Salers"},{"id":"9f7f6f46-739a-4ae2-a30b-c65b298c5cfc","username":"c.dupont-admin@libriciel","email":"pmonin@libriciel.coop","firstName":"camille","lastName":"Dupont"},{"id":"15f2f5a1-689b-40a9-b8e3-83efabca4d30","username":"voxad@libriciel","email":"pmonin@libriciel.coop","firstName":"Ann","lastName":"Shaw"}],"isSms":true,"isComelus":true,"reminder":{"id":"f0213a37-b212-4a48-a7ee-37e116be3a3e","duration":60,"isActive":false},"isSmsGuests":true,"isSmsEmployees":true}';

        $structureId = $this->userApi->getStructure()->getId();
        $typeId = json_decode($type, true)['id'];

        $mockClient = $this->clientMock->mockClient('delete', '/api/v2/structures/' . $structureId . '/types/' . $typeId, $type);
        $typeWrapper = new TypeApiWrapper($mockClient);
        $response = $typeWrapper->delete($typeId);

        $this->assertEquals(204, $response);

    }

}
